/*
 * @Author: wuhao930406 1148547900@qq.com
 * @Date: 2023-08-03 16:51:19
 * @LastEditors: wuhao930406 1148547900@qq.com
 * @LastEditTime: 2023-08-03 17:23:07
 * @FilePath: /socketio_middleware/app/controller/home.js
 * @Description: 
 * 
 * Copyright (c) 2023 by ${git_name_email}, All Rights Reserved. 
 */
/* eslint-disable eqeqeq */
/* eslint-disable array-callback-return */
'use strict';

const { Controller } = require('egg');

class HomeController extends Controller {
  async index() {
    const { ctx } = this;
    ctx.body = 'hi, egg';
  }

  async postmsg() {
    const { ctx, app } = this;

    const { id, msg, mutiplemsg } = ctx.request.body;
    if (!id && !mutiplemsg) {
      ctx.body = {
        code: 0,
        success: true,
        data: ctx.request.body,
      };
      return;
    }

    const clients = app.io.sockets.sockets;
    // query中的id为 用户id  io可以直接emit
    Object.values(clients)?.map(io => {
      const key = io?.handshake?.query?.id;
      if (mutiplemsg) {
        mutiplemsg?.map(it => {
          console.log('====================================');
          console.log(it);
          console.log('====================================');
          if (it?.id == key) {
            io.emit('message', it?.msg);
          }
        });
      } else {
        const index = id.indexOf(key);
        console.log(io);
        if (Array.isArray(id) && index !== -1) {
          io.emit('message', msg);
        } else if (key === id) {
          io.emit('message', msg);
        }
        return io;
      }
    });

    ctx.body = {
      code: 0,
      success: true,
      data: ctx.request.body,
    };
  }
}

module.exports = HomeController;
